
;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 4,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 256 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : Yes
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Ok=R4
	.DEF _Down=R3
	.DEF _Up=R6
	.DEF _key=R5
	.DEF _hr=R8
	.DEF _mins=R7
	.DEF _sec=R10
	.DEF _msec=R9
	.DEF _day=R12
	.DEF _B5=R11
	.DEF _C0=R14
	.DEF _H=R13

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_P2:
	.DB  0xDB,0xF,0xC9,0x40
_DR:
	.DB  0x35,0xFA,0x8E,0x3C
_K1:
	.DB  0x82,0x68,0x86,0x3E
_days_month:
	.DB  0x1F,0x1C,0x1F,0x1E,0x1F,0x1E,0x1F,0x1F
	.DB  0x1E,0x1F,0x1E,0x1F

;DATA STACK END MARKER INITIALIZATION
__DSTACK_END:
	.DB  'D','S','T','A','C','K','E','N','D',0

;HARDWARE STACK END MARKER INITIALIZATION
__HSTACK_END:
	.DB  'H','S','T','A','C','K','E','N','D',0

;HEAP START MARKER INITIALIZATION
__HEAP_START_MARKER:
	.DW  0,0

_0x3:
	.DB  0x21
_0x4:
	.DB  0xA
_0x5:
	.DB  0xD9,0x7,0x0,0x0
_0x6:
	.DB  0x3,0x0,0x0,0x0
_0x7:
	.DB  0x0,0x0,0x0,0x0
_0x8:
	.DB  0x3A
_0x5C:
	.DB  0x1D,0x1B,0x1F,0x1E,0x0,0x0,0x0,0x0
	.DB  0x45,0x8,0x3
_0x0:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0,0x5A,0x0,0x2F,0x0,0x41,0x73,0x74
	.DB  0x72,0x6F,0x54,0x69,0x6D,0x65,0x72,0x20
	.DB  0x76,0x2E,0x31,0x2E,0x30,0x0,0x4C,0x61
	.DB  0x74,0x69,0x74,0x75,0x64,0x65,0x0,0x4C
	.DB  0x6F,0x6E,0x67,0x69,0x74,0x75,0x64,0x65
	.DB  0x0,0x5A,0x6F,0x6E,0x65,0x0,0x43,0x6F
	.DB  0x72,0x72,0x20,0x2B,0x2D,0x20,0x6D,0x69
	.DB  0x6E,0x73,0x0,0x4D,0x6F,0x6E,0x74,0x68
	.DB  0x0,0x44,0x61,0x79,0x0,0x59,0x65,0x61
	.DB  0x72,0x0,0x48,0x6F,0x75,0x72,0x0,0x4D
	.DB  0x69,0x6E,0x0
_0x2020003:
	.DB  0x80,0xC0,0x0,0x0
_0x204005F:
	.DB  0x1,0x0,0x0,0x0
_0x2040000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0
_0x2080003:
	.DB  0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x09
	.DW  0x60
	.DW  __DSTACK_END*2

	.DW  0x09
	.DW  0x00
	.DW  __HSTACK_END*2

	.DW  0x04
	.DW  0x360
	.DW  __HEAP_START_MARKER*2

	.DW  0x01
	.DW  _lat
	.DW  _0x3*2

	.DW  0x01
	.DW  _cor
	.DW  _0x4*2

	.DW  0x04
	.DW  _Y
	.DW  _0x5*2

	.DW  0x04
	.DW  _M
	.DW  _0x6*2

	.DW  0x04
	.DW  _cc
	.DW  _0x7*2

	.DW  0x01
	.DW  _delim
	.DW  _0x8*2

	.DW  0x0B
	.DW  0x03
	.DW  _0x5C*2

	.DW  0x04
	.DW  __base_y_G101
	.DW  _0x2020003*2

	.DW  0x04
	.DW  __seed_G102
	.DW  _0x204005F*2

	.DW  0x02
	.DW  _p_S1040024
	.DW  _0x2080003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x35F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x35F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;Chip type           : ATmega8
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <math.h>
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x12 ;PORTD
; 0000 000B #endasm
;#include <lcd.h>
;
;// Declare your global variables here
;#define light_on  PORTB.0=1;
;#define light_off PORTB.0=0;
;
;unsigned char Ok=27, Down=29, Up=30, key=31;
;
;const float P2=6.283185308;
;const float DR=0.017453293;
;const float K1=0.262516090;
;
;const unsigned char days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
;
;unsigned char  hr, mins, sec, msec, day=8, B5=69, C0, H=3, lat=33, cor=10; // (kor=10  )

	.DSEG
;
;long int J3, Y=2009, M=3, cc = 0;
;
;long int MM[2], HH[2];
;
;float aA[2], aD[2];
;
;float D, T, T0, TT, A, B, A0, D0, D1, E, F, J, S, L, G, V, U, V0, V1, V2;
;
;bit M8, W8, st;
;
;
;
;char delim=':';
;
;// Declare your global variables here
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 002E {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 002F   cc++;
	LDI  R26,LOW(_cc)
	LDI  R27,HIGH(_cc)
	RCALL SUBOPT_0x0
; 0000 0030   if (cc>=1000) {msec++; cc=0;};//   !!! cc>=?
	LDS  R26,_cc
	LDS  R27,_cc+1
	LDS  R24,_cc+2
	LDS  R25,_cc+3
	__CPD2N 0x3E8
	BRLT _0x9
	INC  R9
	LDI  R30,LOW(0)
	STS  _cc,R30
	STS  _cc+1,R30
	STS  _cc+2,R30
	STS  _cc+3,R30
_0x9:
; 0000 0031     // Place your code here
; 0000 0032 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;
;// Timer 2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0036 {
_timer2_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 0037   key=PINC & 0b00011111;// 
	IN   R30,0x13
	ANDI R30,LOW(0x1F)
	MOV  R5,R30
; 0000 0038 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;void me_delay(void)
; 0000 003B {
_me_delay:
; 0000 003C   delay_ms(200);
	RCALL SUBOPT_0x1
; 0000 003D   key=0;
	CLR  R5
; 0000 003E }
	RET
;
;void cld_cls(void)
; 0000 0041 {
_cld_cls:
; 0000 0042   lcd_gotoxy(0,0);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
; 0000 0043   lcd_putsf("                ");//16 
	__POINTW1FN _0x0,0
	RCALL SUBOPT_0x3
	RCALL _lcd_putsf
; 0000 0044   HH[0]=0; MM[0]= 0; //
	LDI  R30,LOW(0)
	STS  _HH,R30
	STS  _HH+1,R30
	STS  _HH+2,R30
	STS  _HH+3,R30
	STS  _MM,R30
	STS  _MM+1,R30
	STS  _MM+2,R30
	STS  _MM+3,R30
; 0000 0045   HH[1]=0; MM[1]= 0; //
	__POINTW1MN _HH,4
	RCALL SUBOPT_0x4
	__POINTW1MN _MM,4
	RCALL SUBOPT_0x4
; 0000 0046 }
	RET
;
;// Declare your global variables here
;
;float Abs(float x)
; 0000 004B {
_Abs:
; 0000 004C   return( x<0 ?-x:x);
;	x -> Y+0
	RCALL SUBOPT_0x5
	BRPL _0xA
	RCALL SUBOPT_0x6
	RCALL __ANEGF1
	RJMP _0xB
_0xA:
	RCALL SUBOPT_0x6
_0xB:
	RJMP _0x20A0005
; 0000 004D }
;
;
;int Sgn(float x)
; 0000 0051 {
_Sgn:
; 0000 0052   return( x>=0 ?1:-1);
;	x -> Y+0
	RCALL SUBOPT_0x5
	BRMI _0xD
	RCALL SUBOPT_0x7
	RJMP _0xE
_0xD:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0xE:
	RJMP _0x20A0005
; 0000 0053 }
;
;long int Trunc (float x)
; 0000 0056 {
_Trunc:
; 0000 0057   if (x>=0) {x=floor(x);}
;	x -> Y+0
	RCALL SUBOPT_0x5
	BRMI _0x10
	RCALL SUBOPT_0x8
	RCALL _floor
	RJMP _0x5A
; 0000 0058   else {x=ceil(x);}
_0x10:
	RCALL SUBOPT_0x8
	RCALL _ceil
_0x5A:
	__PUTD1S 0
; 0000 0059   return (long int)x;
	RCALL SUBOPT_0x6
	RCALL __CFD1
_0x20A0005:
	ADIW R28,4
	RET
; 0000 005A }
;
;void sun_info()
; 0000 005D { int i;
_sun_info:
; 0000 005E   for (i=0; i<2; i++)
	RCALL __SAVELOCR2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x13:
	__CPWRN 16,17,2
	BRGE _0x14
; 0000 005F   {
; 0000 0060     lcd_gotoxy(6*i,0);
	MOVW R30,R16
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	RCALL __MULW12
	ST   -Y,R30
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
; 0000 0061     lcd_putchar (HH[i]/10%10+0x30);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
; 0000 0062     lcd_putchar (HH[i]%10+0x30);
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xB
; 0000 0063     lcd_putchar (':');
	LDI  R30,LOW(58)
	RCALL SUBOPT_0xC
; 0000 0064     lcd_putchar (MM[i]/10%10+0x30);  //+kor
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xA
; 0000 0065     lcd_putchar (MM[i]%10+0x30);     //+kor
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xB
; 0000 0066   }
	__ADDWRN 16,17,1
	RJMP _0x13
_0x14:
; 0000 0067 }
	RCALL __LOADLOCR2P
	RET
;
;void Calendar(void)        //G,Y,D,D1,J,M,F,S,J3
; 0000 006A {
_Calendar:
; 0000 006B //  G = 1;
; 0000 006C //  if (Y < 1583) {G = 0;};//2009
; 0000 006D   D1 = Trunc(D);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	LDI  R26,LOW(_D1)
	LDI  R27,HIGH(_D1)
	RCALL __CDF1
	RCALL __PUTDP1
; 0000 006E   F = D - D1 - 0.5;
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xE
	RCALL __SUBF12
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x14
; 0000 006F   J = -Trunc(7 * (Trunc((M + 9) / 12) + Y) / 4);
	RCALL SUBOPT_0x15
	__ADDD1N 9
	RCALL SUBOPT_0x11
	__GETD1N 0xC
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	RCALL __ADDD12
	__GETD2N 0x7
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x16
	RCALL __ANEGD1
	LDI  R26,LOW(_J)
	LDI  R27,HIGH(_J)
	RCALL __CDF1
	RCALL SUBOPT_0x19
; 0000 0070 //  if (G == 1)
; 0000 0071 //  {
; 0000 0072     S = Sgn(M - 9);
	RCALL _Sgn
	LDI  R26,LOW(_S)
	LDI  R27,HIGH(_S)
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x19
; 0000 0073     //A = Abs(M - 9);
; 0000 0074     J3 = Trunc(Y + S * Trunc(Abs(M - 9)/7)); //A / 7));
	RCALL _Abs
	RCALL SUBOPT_0x11
	__GETD1N 0x40E00000
	RCALL __DIVF21
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1B
	RCALL __CDF1
	RCALL __MULF12
	RCALL SUBOPT_0x17
	RCALL __CDF2
	RCALL __ADDF12
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1C
; 0000 0075     J3 =( -(((J3 / 100) + 1) * 3 / 4));
	LDS  R26,_J3
	LDS  R27,_J3+1
	LDS  R24,_J3+2
	LDS  R25,_J3+3
	RCALL SUBOPT_0x1D
	RCALL __DIVD21
	__ADDD1N 1
	__GETD2N 0x3
	RCALL SUBOPT_0x18
	RCALL __DIVD21
	RCALL __ANEGD1
	RCALL SUBOPT_0x1C
; 0000 0076 //  }
; 0000 0077   J = J + Trunc(275 * M / 9) + D1 + J3;
	RCALL SUBOPT_0x15
	__GETD2N 0x113
	RCALL __MULD12
	RCALL SUBOPT_0x11
	__GETD1N 0x9
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x10
	RCALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	LDS  R30,_J3
	LDS  R31,_J3+1
	LDS  R22,_J3+2
	LDS  R23,_J3+3
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
; 0000 0078   J = J + 1721029 + 367 * Y;
	LDS  R30,_J
	LDS  R31,_J+1
	LDS  R22,_J+2
	LDS  R23,_J+3
	__GETD2N 0x49D21628
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x21
	__GETD2N 0x16F
	RCALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
; 0000 0079   if (F >= 0) {goto end1;};
	LDS  R26,_F+3
	TST  R26
	BRPL _0x16
; 0000 007A   F = F + 1;
	LDS  R30,_F
	LDS  R31,_F+1
	LDS  R22,_F+2
	LDS  R23,_F+3
	RCALL SUBOPT_0x22
	RCALL __ADDF12
	RCALL SUBOPT_0x14
; 0000 007B   J = J - 1;
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x20
; 0000 007C end1:
_0x16:
; 0000 007D }
	RET
;
;void GetTimeZone(void)       //S,T0,T,lat,H,DR
; 0000 0080 {
_GetTimeZone:
; 0000 0081   //T0 = T / 36525;
; 0000 0082   S = 24110.5 + 8640184.813 * T / 36525;//T0;
	RCALL SUBOPT_0x24
	__GETD2N 0x4B03D6B9
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	__GETD2N 0x46BC5D00
	RCALL SUBOPT_0x27
; 0000 0083 
; 0000 0084   S = S -(86636.6 * (float) H / 24) + 86400 * lat/ 360;//L5;
	RCALL SUBOPT_0x28
	__GETD2N 0x47A9364D
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x13
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x2A
	__GETD2N 0x15180
	RCALL __MULD12
	RCALL SUBOPT_0x11
	__GETD1N 0x168
	RCALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x2B
; 0000 0085   S = S / 86400;
	RCALL SUBOPT_0x1B
	__GETD1N 0x47A8C000
	RCALL __DIVF21
	RCALL SUBOPT_0x2B
; 0000 0086   S = S - Trunc(S);
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2B
; 0000 0087   T0 = S * 360 * DR;
	RCALL SUBOPT_0x1B
	__GETD1N 0x43B40000
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x2E
	RCALL __MULF12
	STS  _T0,R30
	STS  _T0+1,R31
	STS  _T0+2,R22
	STS  _T0+3,R23
; 0000 0088 }
	RET
;
;float GetAtan()
; 0000 008B {
_GetAtan:
; 0000 008C   return atan(S / sqrt(1 - S * S));
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x1B
	RCALL __MULF12
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2F
	RCALL __PUTPARD1
	RCALL _atan
	RET
; 0000 008D }
;
;void PosOfSun(char ind)        //(L,G,V,U),P2,T,TT,S
; 0000 0090 {
_PosOfSun:
; 0000 0091 
; 0000 0092   //       
; 0000 0093   //  (Van Flandern & Pulkkinen, 1979)
; 0000 0094   L = 0.779072 + 0.00273790931 * T;
;	ind -> Y+0
	RCALL SUBOPT_0x24
	__GETD2N 0x3B336E7F
	RCALL __MULF12
	__GETD2N 0x3F477143
	RCALL SUBOPT_0x30
; 0000 0095   G = 0.993126 + 0.0027377785 * T;
	RCALL SUBOPT_0x24
	__GETD2N 0x3B336C4D
	RCALL __MULF12
	__GETD2N 0x3F7E3D81
	RCALL SUBOPT_0x31
; 0000 0096   L = L - Trunc(L);
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x34
; 0000 0097   G = G - Trunc(G);
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x37
; 0000 0098   L = L * P2;
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x33
	RCALL __MULF12
	RCALL SUBOPT_0x34
; 0000 0099   G = G * P2;
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x36
	RCALL __MULF12
	RCALL SUBOPT_0x37
; 0000 009A   V = 0.39785 * sin(L);
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x39
	__GETD2N 0x3ECBB2FF
	RCALL __MULF12
	RCALL SUBOPT_0x3A
; 0000 009B   V = V - 0.01000 * sin(L - G);
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x32
	RCALL __SUBF12
	RCALL SUBOPT_0x39
	__GETD2N 0x3C23D70A
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x3A
; 0000 009C   V = V + 0.00333 * sin(L + G);
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x33
	RCALL __ADDF12
	RCALL SUBOPT_0x39
	__GETD2N 0x3B5A3C21
	RCALL SUBOPT_0x3B
	RCALL __ADDF12
	RCALL SUBOPT_0x3A
; 0000 009D   V = V - 0.00021 * TT * sin(L);
	RCALL SUBOPT_0x3C
	__GETD2N 0x395C3372
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x39
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x3A
; 0000 009E 
; 0000 009F   U = 1 - 0.03349 * cos(G);
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x3D
	__GETD2N 0x3D092CCF
	RCALL __MULF12
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x3E
; 0000 00A0   U = U - 0.00014 * cos(2 * L);
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x3D
	__GETD2N 0x3912CCF7
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x3E
; 0000 00A1   U = U + 0.00008 * cos(L);
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x41
	RCALL SUBOPT_0x40
	RCALL __ADDF12
	RCALL SUBOPT_0x3E
; 0000 00A2 
; 0000 00A3   S = -0.00010 - 0.04129 * sin(2 * L);
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x39
	__GETD2N 0x3D291FB4
	RCALL __MULF12
	__GETD2N 0xB8D1B717
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2B
; 0000 00A4   S = S + 0.03211 * sin(G);
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x39
	__GETD2N 0x3D0385C6
	RCALL __MULF12
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x27
; 0000 00A5   S = S + 0.00104 * sin(2 * L - G);
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x36
	RCALL __SUBF12
	RCALL SUBOPT_0x39
	__GETD2N 0x3A88509C
	RCALL __MULF12
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x27
; 0000 00A6   S = S - 0.00035 * sin(2 * L + G);
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x3F
	RCALL SUBOPT_0x36
	RCALL __ADDF12
	RCALL SUBOPT_0x39
	__GETD2N 0x39B78034
	RCALL __MULF12
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2B
; 0000 00A7   S = S - 0.00008 * TT * sin(G);
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0x41
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x39
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2B
; 0000 00A8   S = S / sqrt(U - V * V);
	LDS  R30,_V
	LDS  R31,_V+1
	LDS  R22,_V+2
	LDS  R23,_V+3
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x2B
; 0000 00A9 
; 0000 00AA   aA[ind] = L + GetAtan();//A5;
	LD   R30,Y
	LDI  R26,LOW(_aA)
	LDI  R27,HIGH(_aA)
	RCALL SUBOPT_0x43
	PUSH R31
	PUSH R30
	RCALL _GetAtan
	RCALL SUBOPT_0x33
	RCALL __ADDF12
	POP  R26
	POP  R27
	RCALL __PUTDP1
; 0000 00AB   S = V / sqrt(U);
	LDS  R30,_U
	LDS  R31,_U+1
	LDS  R22,_U+2
	LDS  R23,_U+3
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0x42
	RCALL __DIVF21
	RCALL SUBOPT_0x2B
; 0000 00AC   aD[ind] = GetAtan();
	LD   R30,Y
	LDI  R26,LOW(_aD)
	LDI  R27,HIGH(_aD)
	RCALL SUBOPT_0x43
	PUSH R31
	PUSH R30
	RCALL _GetAtan
	POP  R26
	POP  R27
	RCALL __PUTDP1
; 0000 00AD }
	RJMP _0x20A0001
;
;float getV(float vd, float vh)
; 0000 00B0 {
_getV:
; 0000 00B1   return (S * sin(vd) + cos(B5 * DR)* cos(vd) * cos(vh) - cos(DR * 90.833));   //Z;//C * cos(vd) * cos(vh) - Z;
;	vd -> Y+4
;	vh -> Y+0
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x1B
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x3D
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x3D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x8
	RCALL _cos
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x2E
	__GETD2N 0x42B5AA7F
	RCALL __MULF12
	RCALL SUBOPT_0x3D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x13
	RJMP _0x20A0004
; 0000 00B2 }
;
;void PossibleEvents(int Hour)       //KL,A0,L,G,Hour,V0,V1,V2,A,B,D,E
; 0000 00B5 {
_PossibleEvents:
; 0000 00B6   //P = ((float)Hour + 1) / 24;
; 0000 00B7   L = aA[0] + ((float)Hour + 1) / 24 * (aA[1] - aA[0]); // A2 = //P         //DA;
;	Hour -> Y+0
	RCALL SUBOPT_0x46
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1MN _aA,4
	RCALL SUBOPT_0x47
	RCALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	RCALL SUBOPT_0x47
	RCALL SUBOPT_0x30
; 0000 00B8   G = aD[0] + ((float)Hour + 1) / 24 * (aD[1] - aD[0]); // D2 =         //DD;
	RCALL SUBOPT_0x46
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1MN _aD,4
	RCALL SUBOPT_0x48
	RCALL __SUBF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __MULF12
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0x31
; 0000 00B9   st = 0;
	CLT
	BLD  R2,2
; 0000 00BA                                              //L0 = T0 + Hour * K1;
; 0000 00BB                                              //L2 = T0 + Hour * K1 + K1;
; 0000 00BC   A = T0 + Hour * K1 - A0;                   //H0 =
	RCALL SUBOPT_0x49
	LDS  R26,_A0
	LDS  R27,_A0+1
	LDS  R24,_A0+2
	LDS  R25,_A0+3
	RCALL __SUBF12
	RCALL SUBOPT_0x4A
; 0000 00BD   B = T0 + Hour * K1 + K1 - L;               //H2 = //L2 - A2;
	RCALL SUBOPT_0x49
	RCALL SUBOPT_0x11
	LDI  R30,LOW(_K1*2)
	LDI  R31,HIGH(_K1*2)
	RCALL __GETD1PF
	RCALL __ADDF12
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x4B
; 0000 00BE                                              //H1 = (H2 + H0) / 2; //  ,
; 0000 00BF                                              //D1 = (D2 + D0) / 2; //   
; 0000 00C0   if (Hour <= 0) {V0 = getV(D0, A);}         //S * sin(D0) + C * cos(D0) * cos(H0) - Z;}
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CPW02
	BRLT _0x17
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x4D
	RCALL __PUTPARD1
	RCALL _getV
	RCALL SUBOPT_0x4E
; 0000 00C1   V2 = getV(G,B);                            //S * sin(D2) + C * cos(D2) * cos(H2) - Z;
_0x17:
	RCALL SUBOPT_0x35
	RCALL __PUTPARD1
	RCALL SUBOPT_0x4F
	RCALL __PUTPARD1
	RCALL _getV
	STS  _V2,R30
	STS  _V2+1,R31
	STS  _V2+2,R22
	STS  _V2+3,R23
; 0000 00C2   if (Sgn(V0) == Sgn(V2)) {goto end2;}
	RCALL SUBOPT_0x50
	RCALL __PUTPARD1
	RCALL _Sgn
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x51
	RCALL __PUTPARD1
	RCALL _Sgn
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x18
	RJMP _0x19
; 0000 00C3   V1 = getV((G + D0) / 2,(B + A) / 2);      //S * sin(D1) + C * cos(D1) * cos((H2 + H0) / 2) - Z;//cos(H1) - Z;
_0x18:
	RCALL SUBOPT_0x4C
	RCALL SUBOPT_0x36
	RCALL SUBOPT_0x52
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x53
	RCALL SUBOPT_0x52
	RCALL __PUTPARD1
	RCALL _getV
	STS  _V1,R30
	STS  _V1+1,R31
	STS  _V1+2,R22
	STS  _V1+3,R23
; 0000 00C4   A = 2 * V2 - 4 * V1 + 2 * V0;
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x3F
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x54
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x13
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x50
	RCALL SUBOPT_0x3F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __ADDF12
	RCALL SUBOPT_0x4A
; 0000 00C5   B = 4 * V1 - 3 * V0 - V2;
	RCALL SUBOPT_0x54
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x50
	__GETD2N 0x40400000
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x4B
; 0000 00C6   D = B * B - 4 * A * V0;
	RCALL SUBOPT_0x4F
	RCALL SUBOPT_0x53
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x56
	__GETD2N 0x40800000
	RCALL __MULF12
	RCALL SUBOPT_0x57
	RCALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x58
; 0000 00C7   if (D < 0) {goto end2;};
	LDS  R26,_D+3
	TST  R26
	BRPL _0x1A
	RJMP _0x19
_0x1A:
; 0000 00C8   D = sqrt(D);
	RCALL SUBOPT_0xE
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0x58
; 0000 00C9   E = (-B + D) / (2 * A);
	RCALL SUBOPT_0x59
	RCALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x3F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x5A
; 0000 00CA   if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);}
	LDS  R26,_E
	LDS  R27,_E+1
	LDS  R24,_E+2
	LDS  R25,_E+3
	RCALL SUBOPT_0x23
	RCALL __CMPF12
	BREQ PC+3
	BRCS PC+2
	RJMP _0x1C
	LDS  R26,_E+3
	TST  R26
	BRPL _0x1B
_0x1C:
	RCALL SUBOPT_0x59
	RCALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0x3F
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x5A
; 0000 00CB                                             //T3 = Hour + E + 1 / 120; // 
; 0000 00CC   //A = Trunc(Hour + E + 1 / 120);
; 0000 00CD           //H3 =
; 0000 00CE   A = (Hour + E + 1 / 120 );//+ (float)kor/60;//+ kor / 60;  ////// 0.2
_0x1B:
	LDS  R30,_E
	LDS  R31,_E+1
	LDS  R22,_E+2
	LDS  R23,_E+3
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CWD2
	RCALL __CDF2
	RCALL __ADDF12
	__GETD2N 0x0
	RCALL __ADDF12
	RCALL SUBOPT_0x4A
; 0000 00CF   B = Trunc((A - Trunc(A)) * 60); //M3
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0xF
	LDS  R26,_A
	LDS  R27,_A+1
	LDS  R24,_A+2
	LDS  R25,_A+3
	RCALL SUBOPT_0x2D
	__GETD2N 0x42700000
	RCALL __MULF12
	RCALL SUBOPT_0xF
	LDI  R26,LOW(_B)
	LDI  R27,HIGH(_B)
	RCALL __CDF1
	RCALL __PUTDP1
; 0000 00D0   if ((V0 < 0) && (V2 > 0)) {HH[0]=Trunc(A);  MM[0]=Trunc(B);  M8 = 1; st = 1;};    //?????
	LDS  R26,_V0+3
	TST  R26
	BRPL _0x1F
	RCALL SUBOPT_0x55
	RCALL __CPD02
	BRLT _0x20
_0x1F:
	RJMP _0x1E
_0x20:
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0xF
	STS  _HH,R30
	STS  _HH+1,R31
	STS  _HH+2,R22
	STS  _HH+3,R23
	RCALL SUBOPT_0x4F
	RCALL SUBOPT_0xF
	STS  _MM,R30
	STS  _MM+1,R31
	STS  _MM+2,R22
	STS  _MM+3,R23
	SET
	BLD  R2,0
	BLD  R2,2
_0x1E:
; 0000 00D1   if ((V0 > 0) && (V2 < 0)) {HH[1]=Trunc(A);  MM[1]=Trunc(B);  W8 = 1; st = 1;};    //?????
	RCALL SUBOPT_0x57
	RCALL __CPD02
	BRGE _0x22
	LDS  R26,_V2+3
	TST  R26
	BRMI _0x23
_0x22:
	RJMP _0x21
_0x23:
	RCALL SUBOPT_0x56
	RCALL SUBOPT_0xF
	__PUTD1MN _HH,4
	RCALL SUBOPT_0x4F
	RCALL SUBOPT_0xF
	__PUTD1MN _MM,4
	SET
	BLD  R2,1
	BLD  R2,2
_0x21:
; 0000 00D2 end2:
_0x19:
; 0000 00D3   if (st != 0) {sun_info();}
	SBRC R2,2
	RCALL _sun_info
; 0000 00D4   A0 = L;
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x5B
; 0000 00D5   D0 = G;
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x5C
; 0000 00D6   V0 = V2;
	RCALL SUBOPT_0x51
	RCALL SUBOPT_0x4E
; 0000 00D7 }
	RJMP _0x20A0002
;
;
;void OutInform(void)
; 0000 00DB {
_OutInform:
; 0000 00DC  if (((M8 == 0) && (W8 == 0)) && ((V2 < 0) || (V2 > 0)) || ((M8 == 0) || (W8 == 0))) {st=0; cld_cls();}
	RCALL SUBOPT_0x5D
	BRNE _0x26
	RCALL SUBOPT_0x5E
	BREQ _0x27
_0x26:
	RJMP _0x28
_0x27:
	LDS  R26,_V2+3
	TST  R26
	BRMI _0x29
	RCALL SUBOPT_0x55
	RCALL __CPD02
	BRGE _0x28
_0x29:
	RJMP _0x2C
_0x28:
	RCALL SUBOPT_0x5D
	BREQ _0x2D
	RCALL SUBOPT_0x5E
	BRNE _0x2E
_0x2D:
	RJMP _0x2C
_0x2E:
	RJMP _0x25
_0x2C:
	CLT
	BLD  R2,2
	RCALL _cld_cls
; 0000 00DD }
_0x25:
	RET
;
;void show_info(void)             //D,day,T,J,TT,F,H,S,Z
; 0000 00E0 {
_show_info:
; 0000 00E1   D = day;
	MOV  R30,R12
	LDI  R26,LOW(_D)
	LDI  R27,HIGH(_D)
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __PUTDP1
; 0000 00E2   //L5=lat;
; 0000 00E3   //L5 = lat/ 360;
; 0000 00E4   //Z0 = (float) H / 24;
; 0000 00E5   Calendar();
	RCALL _Calendar
; 0000 00E6   T = (J - 2451545) + F;
	RCALL SUBOPT_0x1E
	__GETD1N 0x4A15A164
	RCALL SUBOPT_0x13
	LDS  R26,_F
	LDS  R27,_F+1
	LDS  R24,_F+2
	LDS  R25,_F+3
	RCALL SUBOPT_0x5F
; 0000 00E7   TT = T / 36525 + 1; // TT - ,   1900.0
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x22
	RCALL __ADDF12
	STS  _TT,R30
	STS  _TT+1,R31
	STS  _TT+2,R22
	STS  _TT+3,R23
; 0000 00E8   GetTimeZone(); //   
	RCALL _GetTimeZone
; 0000 00E9   T = T - (float) H / 24;
	RCALL SUBOPT_0x28
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x60
	RCALL SUBOPT_0x13
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
; 0000 00EA   PosOfSun(0); //   
	RCALL SUBOPT_0x2
	RCALL _PosOfSun
; 0000 00EB   T = T + 1;
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x22
	RCALL SUBOPT_0x5F
; 0000 00EC   PosOfSun(1);
	RCALL SUBOPT_0x61
	RCALL _PosOfSun
; 0000 00ED   if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x63
	RCALL __CMPF12
	BRSH _0x30
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x38
	RCALL __ADDF12
	__PUTD1MN _aA,4
; 0000 00EE   S = sin(B5 * DR);
_0x30:
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x2B
; 0000 00EF   M8 = 0;
	CLT
	BLD  R2,0
; 0000 00F0   W8 = 0;
	BLD  R2,1
; 0000 00F1   A0 = aA[0];
	RCALL SUBOPT_0x63
	RCALL SUBOPT_0x5B
; 0000 00F2   D0 = aD[0];
	LDS  R30,_aD
	LDS  R31,_aD+1
	LDS  R22,_aD+2
	LDS  R23,_aD+3
	RCALL SUBOPT_0x5C
; 0000 00F3 
; 0000 00F4   for (C0 = 0; C0 < 24; C0++)
	CLR  R14
_0x32:
	LDI  R30,LOW(24)
	CP   R14,R30
	BRSH _0x33
; 0000 00F5   {PossibleEvents(C0);}
	MOV  R30,R14
	RCALL SUBOPT_0x64
	RCALL _PossibleEvents
	INC  R14
	RJMP _0x32
_0x33:
; 0000 00F6    OutInform();
	RCALL _OutInform
; 0000 00F7 }
	RET
;
;void display(void)
; 0000 00FA {
_display:
; 0000 00FB   lcd_gotoxy(13,0); //13
	LDI  R30,LOW(13)
	ST   -Y,R30
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
; 0000 00FC   lcd_putsf("Z");
	__POINTW1FN _0x0,17
	RCALL SUBOPT_0x65
; 0000 00FD   lcd_putchar (H/10%10+0x30);
	MOV  R26,R13
	RCALL SUBOPT_0x66
; 0000 00FE   lcd_putchar (H%10+0x30);
	MOV  R26,R13
	RCALL SUBOPT_0x67
; 0000 00FF   lcd_gotoxy(0,1);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x61
	RCALL _lcd_gotoxy
; 0000 0100   lcd_putchar (hr/10%10+0x30);
	MOV  R26,R8
	RCALL SUBOPT_0x66
; 0000 0101   lcd_putchar (hr%10+0x30);
	MOV  R26,R8
	RCALL SUBOPT_0x67
; 0000 0102   lcd_putchar (delim);
	LDS  R30,_delim
	RCALL SUBOPT_0xC
; 0000 0103   lcd_putchar (mins/10%10+0x30);
	MOV  R26,R7
	RCALL SUBOPT_0x66
; 0000 0104   lcd_putchar (mins%10+0x30);
	MOV  R26,R7
	RCALL SUBOPT_0x67
; 0000 0105   lcd_putsf (" ");
	__POINTW1FN _0x0,15
	RCALL SUBOPT_0x65
; 0000 0106   lcd_putchar ((day/10)%10+0x30);
	MOV  R26,R12
	RCALL SUBOPT_0x66
; 0000 0107   lcd_putchar (day%10+0x30);
	MOV  R26,R12
	RCALL SUBOPT_0x67
; 0000 0108   lcd_putsf ("/");
	__POINTW1FN _0x0,19
	RCALL SUBOPT_0x65
; 0000 0109   lcd_putchar ((M/10)%10+0x30);
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0xA
; 0000 010A   lcd_putchar (M%10+0x30);
	RCALL SUBOPT_0x68
	RCALL SUBOPT_0xB
; 0000 010B   lcd_putsf ("/");
	__POINTW1FN _0x0,19
	RCALL SUBOPT_0x65
; 0000 010C   lcd_putchar ((Y/1000)%10+0x30);
	RCALL SUBOPT_0x17
	__GETD1N 0x3E8
	RCALL SUBOPT_0xA
; 0000 010D   lcd_putchar ((Y/100)%10+0x30);
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0xA
; 0000 010E   lcd_putchar ((Y/10)%10+0x30);
	RCALL SUBOPT_0x69
	RCALL SUBOPT_0xA
; 0000 010F   lcd_putchar (Y%10+0x30);
	RCALL SUBOPT_0x69
	RCALL SUBOPT_0xB
; 0000 0110 }
	RET
;
;
;void clock(void)
; 0000 0114 { unsigned char qty_days;
_clock:
; 0000 0115   if (msec>=1) //150
	ST   -Y,R17
;	qty_days -> R17
	LDI  R30,LOW(1)
	CP   R9,R30
	BRLO _0x34
; 0000 0116   {
; 0000 0117     msec=0; sec++;
	CLR  R9
	INC  R10
; 0000 0118     if (delim==':') {delim=' ';}
	LDS  R26,_delim
	CPI  R26,LOW(0x3A)
	BRNE _0x35
	LDI  R30,LOW(32)
	RJMP _0x5B
; 0000 0119     else {delim=':';};
_0x35:
	LDI  R30,LOW(58)
_0x5B:
	STS  _delim,R30
; 0000 011A   };
_0x34:
; 0000 011B   if (sec==60) {sec=0; mins++;};  //   ,    60
	LDI  R30,LOW(60)
	CP   R30,R10
	BRNE _0x37
	CLR  R10
	INC  R7
_0x37:
; 0000 011C   if (mins==60) {mins=0; hr++;}; //   ,    60
	LDI  R30,LOW(60)
	CP   R30,R7
	BRNE _0x38
	CLR  R7
	INC  R8
_0x38:
; 0000 011D   if (hr==24) {day++; hr=0; show_info();};//   24
	LDI  R30,LOW(24)
	CP   R30,R8
	BRNE _0x39
	INC  R12
	CLR  R8
	RCALL _show_info
_0x39:
; 0000 011E   qty_days=days_month[M-1];//   
	RCALL SUBOPT_0x15
	__SUBD1N 1
	SUBI R30,LOW(-_days_month*2)
	SBCI R31,HIGH(-_days_month*2)
	LPM  R17,Z
; 0000 011F   if ((M==2) & (Y%4)==(Y/4)) {qty_days=29;}//   
	RCALL SUBOPT_0x6A
	__GETD1N 0x2
	RCALL __EQD12
	PUSH R30
	RCALL SUBOPT_0x6B
	RCALL __MODD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x6B
	RCALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __EQD12
	POP  R26
	AND  R30,R26
	BREQ _0x3A
	LDI  R17,LOW(29)
; 0000 0120   if (day>qty_days) {M++; day=1;};//   
_0x3A:
	CP   R17,R12
	BRSH _0x3B
	LDI  R26,LOW(_M)
	LDI  R27,HIGH(_M)
	RCALL SUBOPT_0x0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	LDI  R30,LOW(1)
	MOV  R12,R30
_0x3B:
; 0000 0121   if (M>12) {M=1; Y++;};//   12
	RCALL SUBOPT_0x6A
	__CPD2N 0xD
	BRLT _0x3C
	__GETD1N 0x1
	RCALL SUBOPT_0x6C
	LDI  R26,LOW(_Y)
	LDI  R27,HIGH(_Y)
	RCALL SUBOPT_0x0
_0x3C:
; 0000 0122 
; 0000 0123   display();
	RCALL _display
; 0000 0124 
; 0000 0125  }
	LD   R17,Y+
	RET
;
; void on_of_led(void)
; 0000 0128   {
_on_of_led:
; 0000 0129     long int time_on, time_off, time_now;//       
; 0000 012A     time_off=(HH[0]*60 + MM[0]) + cor;
	SBIW R28,12
;	time_on -> Y+8
;	time_off -> Y+4
;	time_now -> Y+0
	LDS  R26,_HH
	LDS  R27,_HH+1
	LDS  R24,_HH+2
	LDS  R25,_HH+3
	__GETD1N 0x3C
	RCALL __MULD12
	LDS  R26,_MM
	LDS  R27,_MM+1
	LDS  R24,_MM+2
	LDS  R25,_MM+3
	RCALL SUBOPT_0x6D
	RCALL __ADDD12
	__PUTD1S 4
; 0000 012B     time_on=(HH[1]*60 + MM[1]) - cor;
	__GETD1MN _HH,4
	RCALL SUBOPT_0x6E
	RCALL SUBOPT_0x11
	__GETD1MN _MM,4
	RCALL SUBOPT_0x6D
	RCALL __SUBD21
	__PUTD2S 8
; 0000 012C     time_now=(long int)hr*60 + mins;
	RCALL SUBOPT_0x6F
	RCALL SUBOPT_0x6E
	MOVW R26,R30
	MOVW R24,R22
	RCALL SUBOPT_0x70
	RCALL __ADDD12
	RCALL SUBOPT_0x71
; 0000 012D     if (time_now>=time_on) {light_off;}  //   
	__GETD1S 8
	RCALL SUBOPT_0x72
	RCALL __CPD21
	BRLT _0x3D
	CBI  0x18,0
; 0000 012E     if (time_now<=time_off) {light_on;}   //   
_0x3D:
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x72
	RCALL __CPD12
	BRLT _0x40
	SBI  0x18,0
; 0000 012F   }
_0x40:
	ADIW R28,12
	RET
;
;void keypress(unsigned char ind, long int ddey, int ga, int gb, char sw)
; 0000 0132 {
_keypress:
; 0000 0133   while (key!=Ok)
;	ind -> Y+9
;	ddey -> Y+5
;	ga -> Y+3
;	gb -> Y+1
;	sw -> Y+0
_0x43:
	CP   R4,R5
	BRNE PC+2
	RJMP _0x45
; 0000 0134   {
; 0000 0135     if (sw==1)
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x46
; 0000 0136     {
; 0000 0137       lcd_gotoxy(6,1);
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL SUBOPT_0x61
	RCALL _lcd_gotoxy
; 0000 0138       lcd_putchar (ddey/10%10+0x30);
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0xA
; 0000 0139       lcd_putchar (ddey%10+0x30);
	RCALL SUBOPT_0x73
	RCALL SUBOPT_0xB
; 0000 013A     }
; 0000 013B     else
	RJMP _0x47
_0x46:
; 0000 013C     {
; 0000 013D       display();
	RCALL _display
; 0000 013E     }
_0x47:
; 0000 013F     if ((key==Up) & (ddey<ga)) {ddey++; delay_ms(200);}
	MOV  R30,R6
	MOV  R26,R5
	RCALL __EQB12
	MOV  R0,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	RCALL SUBOPT_0x74
	RCALL __LTD12
	AND  R30,R0
	BREQ _0x48
	RCALL SUBOPT_0x75
	__SUBD1N -1
	RCALL SUBOPT_0x76
; 0000 0140     if ((key==Down) & (ddey>gb)) {ddey--; delay_ms(200);}
_0x48:
	MOV  R30,R3
	MOV  R26,R5
	RCALL __EQB12
	MOV  R0,R30
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RCALL SUBOPT_0x74
	RCALL __GTD12
	AND  R30,R0
	BREQ _0x49
	RCALL SUBOPT_0x75
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	RCALL SUBOPT_0x76
; 0000 0141 
; 0000 0142     if (ind==1) {B5=ddey;}
_0x49:
	LDD  R26,Y+9
	CPI  R26,LOW(0x1)
	BRNE _0x4A
	LDD  R11,Y+5
; 0000 0143     if (ind==2) {lat=(float)ddey;}
_0x4A:
	LDD  R26,Y+9
	CPI  R26,LOW(0x2)
	BRNE _0x4B
	RCALL SUBOPT_0x75
	RCALL __CDF1
	LDI  R26,LOW(_lat)
	LDI  R27,HIGH(_lat)
	RCALL __CFD1U
	ST   X,R30
; 0000 0144     if (ind==3) {M=ddey;}
_0x4B:
	LDD  R26,Y+9
	CPI  R26,LOW(0x3)
	BRNE _0x4C
	RCALL SUBOPT_0x75
	RCALL SUBOPT_0x6C
; 0000 0145     if (ind==4) {day=ddey;}
_0x4C:
	LDD  R26,Y+9
	CPI  R26,LOW(0x4)
	BRNE _0x4D
	LDD  R12,Y+5
; 0000 0146     if (ind==5) {Y=ddey;}
_0x4D:
	LDD  R26,Y+9
	CPI  R26,LOW(0x5)
	BRNE _0x4E
	RCALL SUBOPT_0x75
	STS  _Y,R30
	STS  _Y+1,R31
	STS  _Y+2,R22
	STS  _Y+3,R23
; 0000 0147     if (ind==6) {hr=ddey;}
_0x4E:
	LDD  R26,Y+9
	CPI  R26,LOW(0x6)
	BRNE _0x4F
	LDD  R8,Y+5
; 0000 0148     if (ind==7) {mins=ddey;}
_0x4F:
	LDD  R26,Y+9
	CPI  R26,LOW(0x7)
	BRNE _0x50
	LDD  R7,Y+5
; 0000 0149     if (ind==8) {cor=ddey;}
_0x50:
	LDD  R26,Y+9
	CPI  R26,LOW(0x8)
	BRNE _0x51
	LDD  R30,Y+5
	STS  _cor,R30
; 0000 014A     if (ind==9) {H=ddey;}
_0x51:
	LDD  R26,Y+9
	CPI  R26,LOW(0x9)
	BRNE _0x52
	LDD  R13,Y+5
; 0000 014B   }
_0x52:
	RJMP _0x43
_0x45:
; 0000 014C   me_delay();
	RCALL _me_delay
; 0000 014D   lcd_clear();////////
	RCALL _lcd_clear
; 0000 014E   lcd_gotoxy(0,0);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
; 0000 014F }
	ADIW R28,10
	RET
;
;
;
;void main(void)
; 0000 0154 {
_main:
; 0000 0155 
; 0000 0156 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 0157 DDRB=0x01;
	LDI  R30,LOW(1)
	OUT  0x17,R30
; 0000 0158 
; 0000 0159 PORTC=0x1F;
	LDI  R30,LOW(31)
	OUT  0x15,R30
; 0000 015A DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
; 0000 015B 
; 0000 015C PORTD=0x00;
	OUT  0x12,R30
; 0000 015D DDRD=0xF7;
	LDI  R30,LOW(247)
	OUT  0x11,R30
; 0000 015E 
; 0000 015F TCCR0=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 0160 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0161 //OCR0=0x00;///////
; 0000 0162 
; 0000 0163 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0164 TCCR1B=0x00;//5
	OUT  0x2E,R30
; 0000 0165 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0166 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0167 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0168 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0169 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 016A OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 016B OCR1BH=0x00;
	OUT  0x29,R30
; 0000 016C OCR1BL=0x00;
	OUT  0x28,R30
; 0000 016D 
; 0000 016E ASSR=0x00;
	OUT  0x22,R30
; 0000 016F TCCR2=0x07;//3
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 0170 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0171 OCR2=0x00;
	OUT  0x23,R30
; 0000 0172 
; 0000 0173 MCUCR=0x00;
	OUT  0x35,R30
; 0000 0174 
; 0000 0175 TIMSK=0x41;//00
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 0176 
; 0000 0177 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 0178 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0179 
; 0000 017A /// LCD module initialization
; 0000 017B lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 017C 
; 0000 017D #asm("sei")
	sei
; 0000 017E 
; 0000 017F 
; 0000 0180 lcd_gotoxy(0,0);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x2
	RCALL _lcd_gotoxy
; 0000 0181 lcd_putsf("AstroTimer v.1.0");
	__POINTW1FN _0x0,21
	RCALL SUBOPT_0x65
; 0000 0182 
; 0000 0183 while (key!=Ok){}
_0x53:
	CP   R4,R5
	BRNE _0x53
; 0000 0184 me_delay();
	RCALL _me_delay
; 0000 0185 lcd_clear();
	RCALL _lcd_clear
; 0000 0186 
; 0000 0187 //lcd_gotoxy(6,0);
; 0000 0188 lcd_putsf("Latitude");
	__POINTW1FN _0x0,38
	RCALL SUBOPT_0x65
; 0000 0189 keypress(1, B5, 90, 0, 1);
	RCALL SUBOPT_0x61
	MOV  R30,R11
	RCALL SUBOPT_0x77
	LDI  R30,LOW(90)
	LDI  R31,HIGH(90)
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
; 0000 018A lcd_clear();
; 0000 018B 
; 0000 018C //lcd_gotoxy(6,0);
; 0000 018D lcd_putsf("Longitude"); //Dolg
	__POINTW1FN _0x0,47
	RCALL SUBOPT_0x65
; 0000 018E keypress(2, lat, 180, 0, 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL SUBOPT_0x2A
	RCALL __PUTPARD1
	LDI  R30,LOW(180)
	LDI  R31,HIGH(180)
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
; 0000 018F lcd_clear();
; 0000 0190 
; 0000 0191 lcd_putsf("Zone");
	__POINTW1FN _0x0,57
	RCALL SUBOPT_0x65
; 0000 0192 keypress(9, H, 12, 0, 1);
	LDI  R30,LOW(9)
	ST   -Y,R30
	MOV  R30,R13
	RCALL SUBOPT_0x77
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL SUBOPT_0x78
	RCALL _keypress
; 0000 0193 
; 0000 0194 //lcd_gotoxy(4,0);
; 0000 0195 lcd_putsf("Corr +- mins");
	__POINTW1FN _0x0,62
	RCALL SUBOPT_0x65
; 0000 0196 keypress(8, cor, 59, 0, 1);  //
	LDI  R30,LOW(8)
	ST   -Y,R30
	LDS  R30,_cor
	RCALL SUBOPT_0x77
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	RCALL SUBOPT_0x78
	RCALL SUBOPT_0x79
; 0000 0197 lcd_clear();
; 0000 0198 
; 0000 0199 //lcd_gotoxy(0,0);
; 0000 019A lcd_putsf("Month");
	__POINTW1FN _0x0,75
	RCALL SUBOPT_0x65
; 0000 019B keypress(3, M, 12, 1, 0);
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL SUBOPT_0x15
	RCALL __PUTPARD1
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	RCALL SUBOPT_0x7A
	RCALL _keypress
; 0000 019C //lcd_clear();
; 0000 019D 
; 0000 019E lcd_putsf("Day");
	__POINTW1FN _0x0,81
	RCALL SUBOPT_0x65
; 0000 019F keypress(4,day,days_month[M], 1, 0);
	LDI  R30,LOW(4)
	ST   -Y,R30
	MOV  R30,R12
	RCALL SUBOPT_0x77
	RCALL SUBOPT_0x15
	SUBI R30,LOW(-_days_month*2)
	SBCI R31,HIGH(-_days_month*2)
	LPM  R30,Z
	RCALL SUBOPT_0x64
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2
	RCALL _keypress
; 0000 01A0 
; 0000 01A1 lcd_putsf("Year");
	__POINTW1FN _0x0,85
	RCALL SUBOPT_0x65
; 0000 01A2 keypress(5, Y, 2100, 2000, 0);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL SUBOPT_0x21
	RCALL __PUTPARD1
	LDI  R30,LOW(2100)
	LDI  R31,HIGH(2100)
	RCALL SUBOPT_0x3
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2
	RCALL _keypress
; 0000 01A3 
; 0000 01A4 lcd_putsf("Hour");
	__POINTW1FN _0x0,90
	RCALL SUBOPT_0x65
; 0000 01A5 keypress(6, hr, 24, 1, 0);
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL SUBOPT_0x6F
	RCALL __PUTPARD1
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	RCALL SUBOPT_0x7A
	RCALL _keypress
; 0000 01A6 
; 0000 01A7 lcd_putsf("Min");
	__POINTW1FN _0x0,95
	RCALL SUBOPT_0x65
; 0000 01A8 keypress(7,mins, 59, 1, 0);
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL SUBOPT_0x70
	RCALL __PUTPARD1
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	RCALL SUBOPT_0x7A
	RCALL SUBOPT_0x79
; 0000 01A9 
; 0000 01AA //lcd_putsf("Zone");
; 0000 01AB //keypress(9, H, 12, 0, 0);
; 0000 01AC /*while (key!=Ok)
; 0000 01AD {
; 0000 01AE   display();
; 0000 01AF   if ((key==Up) & (H<12)) {H++; delay_ms(200);}
; 0000 01B0   if ((key==Down) & (H>0)) {H--; delay_ms(200);}
; 0000 01B1   // 0  ()   180   -  
; 0000 01B2 }*/
; 0000 01B3 
; 0000 01B4 lcd_clear();
; 0000 01B5 clock();
	RCALL _clock
; 0000 01B6 show_info();
	RCALL _show_info
; 0000 01B7 
; 0000 01B8 while (1)
_0x56:
; 0000 01B9       {
; 0000 01BA       // Place your code here
; 0000 01BB           clock();
	RCALL _clock
; 0000 01BC           on_of_led();
	RCALL _on_of_led
; 0000 01BD       };
	RJMP _0x56
; 0000 01BE }
_0x59:
	RJMP _0x59

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	RCALL SUBOPT_0x8
	RCALL _ftrunc
	RCALL SUBOPT_0x71
    brne __floor1
__floor0:
	RCALL SUBOPT_0x6
	RJMP _0x20A0003
__floor1:
    brtc __floor0
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x13
	RJMP _0x20A0003
_ceil:
	RCALL SUBOPT_0x8
	RCALL _ftrunc
	RCALL SUBOPT_0x71
    brne __ceil1
__ceil0:
	RCALL SUBOPT_0x6
	RJMP _0x20A0003
__ceil1:
    brts __ceil0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x22
	RCALL __ADDF12
	RJMP _0x20A0003
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	RCALL SUBOPT_0x7B
	__GETD1N 0x3E22F983
	RCALL __MULF12
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x75
	RCALL __PUTPARD1
	RCALL _floor
	RCALL SUBOPT_0x7B
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x7C
	RCALL SUBOPT_0x7B
	RCALL SUBOPT_0x12
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000017
	RCALL SUBOPT_0x7B
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x7C
	LDI  R17,LOW(1)
_0x2000017:
	RCALL SUBOPT_0x7B
	__GETD1N 0x3E800000
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000018
	RCALL SUBOPT_0x7B
	RCALL SUBOPT_0x12
	RCALL __SUBF12
	RCALL SUBOPT_0x7C
_0x2000018:
	CPI  R17,0
	BREQ _0x2000019
	RCALL SUBOPT_0x75
	RCALL __ANEGF1
	RCALL SUBOPT_0x7C
_0x2000019:
	RCALL SUBOPT_0x75
	RCALL SUBOPT_0x7B
	RCALL __MULF12
	__PUTD1S 1
	RCALL SUBOPT_0x7D
	__GETD2N 0x4226C4B1
	RCALL SUBOPT_0x25
	__GETD1N 0x422DE51D
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x7E
	__GETD2N 0x4104534C
	RCALL __ADDF12
	RCALL SUBOPT_0x7B
	RCALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x7D
	__GETD2N 0x3FDEED11
	RCALL __ADDF12
	RCALL SUBOPT_0x7E
	__GETD2N 0x3FA87B5E
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	RCALL SUBOPT_0x72
	__GETD1N 0x3FC90FDB
	RCALL __SUBF12
	RCALL SUBOPT_0x39
	RJMP _0x20A0003
_xatan:
	SBIW R28,4
	RCALL SUBOPT_0x44
	RCALL SUBOPT_0x7F
	RCALL SUBOPT_0x71
	RCALL SUBOPT_0x6
	__GETD2N 0x40CBD065
	RCALL SUBOPT_0x80
	RCALL SUBOPT_0x7F
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x6
	__GETD2N 0x41296D00
	RCALL __ADDF12
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x80
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
_0x20A0004:
	ADIW R28,8
	RET
_yatan:
	RCALL SUBOPT_0x72
	__GETD1N 0x3ED413CD
	RCALL __CMPF12
	BRSH _0x2000020
	RCALL SUBOPT_0x8
	RCALL _xatan
	RJMP _0x20A0003
_0x2000020:
	RCALL SUBOPT_0x72
	__GETD1N 0x401A827A
	RCALL __CMPF12
	BREQ PC+2
	BRCC PC+2
	RJMP _0x2000021
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x22
	RCALL __DIVF21
	RCALL __PUTPARD1
	RCALL _xatan
	__GETD2N 0x3FC90FDB
	RCALL SUBOPT_0x13
	RJMP _0x20A0003
_0x2000021:
	RCALL SUBOPT_0x72
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x13
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x22
	RCALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL __DIVF21
	RCALL __PUTPARD1
	RCALL _xatan
	__GETD2N 0x3F490FDB
	RCALL __ADDF12
	RJMP _0x20A0003
_atan:
	RCALL SUBOPT_0x5
	BRMI _0x200002C
	RCALL SUBOPT_0x8
	RCALL _yatan
	RJMP _0x20A0003
_0x200002C:
	RCALL SUBOPT_0x6
	RCALL __ANEGF1
	RCALL __PUTPARD1
	RCALL _yatan
	RCALL __ANEGF1
_0x20A0003:
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G101:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G101
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G101:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G101
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G101
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x20A0001
__lcd_read_nibble_G101:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
    andi  r30,0xf0
	RET
_lcd_read_byte0_G101:
	RCALL __lcd_delay_G101
	RCALL __lcd_read_nibble_G101
    mov   r26,r30
	RCALL __lcd_read_nibble_G101
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x81
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x20A0002:
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x81
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x81
	RCALL __lcd_ready
	RCALL SUBOPT_0x61
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2020004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x2
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2020004:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x20A0001
_lcd_putsf:
	ST   -Y,R17
_0x2020008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x202000A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020008
_0x202000A:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G101:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G101:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G101
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x20A0001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	RCALL SUBOPT_0x82
	RCALL SUBOPT_0x82
	RCALL SUBOPT_0x82
	RCALL __long_delay_G101
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G101
	RCALL __long_delay_G101
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x81
	RCALL __long_delay_G101
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x81
	RCALL __long_delay_G101
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x81
	RCALL __long_delay_G101
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G101
	CPI  R30,LOW(0x5)
	BREQ _0x202000B
	LDI  R30,LOW(0)
	RJMP _0x20A0001
_0x202000B:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x81
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x20A0001:
	ADIW R28,1
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG

	.CSEG

	.DSEG
_lat:
	.BYTE 0x1
_cor:
	.BYTE 0x1
_J3:
	.BYTE 0x4
_Y:
	.BYTE 0x4
_M:
	.BYTE 0x4
_cc:
	.BYTE 0x4
_MM:
	.BYTE 0x8
_HH:
	.BYTE 0x8
_aA:
	.BYTE 0x8
_aD:
	.BYTE 0x8
_D:
	.BYTE 0x4
_T:
	.BYTE 0x4
_T0:
	.BYTE 0x4
_TT:
	.BYTE 0x4
_A:
	.BYTE 0x4
_B:
	.BYTE 0x4
_A0:
	.BYTE 0x4
_D0:
	.BYTE 0x4
_D1:
	.BYTE 0x4
_E:
	.BYTE 0x4
_F:
	.BYTE 0x4
_J:
	.BYTE 0x4
_S:
	.BYTE 0x4
_L:
	.BYTE 0x4
_G:
	.BYTE 0x4
_V:
	.BYTE 0x4
_U:
	.BYTE 0x4
_V0:
	.BYTE 0x4
_V1:
	.BYTE 0x4
_V2:
	.BYTE 0x4
_delim:
	.BYTE 0x1
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
__seed_G102:
	.BYTE 0x4
_p_S1040024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x0:
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 34 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4:
	__GETD2N 0x0
	__PUTDZ2 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDD  R26,Y+3
	TST  R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:49 WORDS
SUBOPT_0x6:
	__GETD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	RCALL SUBOPT_0x6
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x9:
	MOVW R30,R16
	LDI  R26,LOW(_HH)
	LDI  R27,HIGH(_HH)
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:76 WORDS
SUBOPT_0xA:
	RCALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	RCALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0xB:
	RCALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xD:
	MOVW R30,R16
	LDI  R26,LOW(_MM)
	LDI  R27,HIGH(_MM)
	RCALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xE:
	LDS  R30,_D
	LDS  R31,_D+1
	LDS  R22,_D+2
	LDS  R23,_D+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xF:
	RCALL __PUTPARD1
	RJMP _Trunc

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	LDS  R26,_D1
	LDS  R27,_D1+1
	LDS  R24,_D1+2
	LDS  R25,_D1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x11:
	MOVW R26,R30
	MOVW R24,R22
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x12:
	__GETD1N 0x3F000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x13:
	RCALL __SWAPD12
	RCALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	STS  _F,R30
	STS  _F+1,R31
	STS  _F+2,R22
	STS  _F+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x15:
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	RCALL __DIVD21
	RCALL __CDF1
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x17:
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x18:
	RCALL __MULD12
	RCALL SUBOPT_0x11
	__GETD1N 0x4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x19:
	RCALL __PUTDP1
	RCALL SUBOPT_0x15
	__SUBD1N 9
	RCALL __CDF1
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	RCALL __CWD1
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:82 WORDS
SUBOPT_0x1B:
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1C:
	STS  _J3,R30
	STS  _J3+1,R31
	STS  _J3+2,R22
	STS  _J3+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	__GETD1N 0x64
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1E:
	LDS  R26,_J
	LDS  R27,_J+1
	LDS  R24,_J+2
	LDS  R25,_J+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	RCALL __CDF1
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x20:
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x21:
	LDS  R30,_Y
	LDS  R31,_Y+1
	LDS  R22,_Y+2
	LDS  R23,_Y+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x22:
	__GETD2N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x23:
	__GETD1N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x24:
	LDS  R30,_T
	LDS  R31,_T+1
	LDS  R22,_T+2
	LDS  R23,_T+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x25:
	RCALL __MULF12
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x26:
	__GETD1N 0x470EAD00
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x27:
	RCALL __ADDF12
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x28:
	MOV  R30,R13
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x29:
	__GETD1N 0x41C00000
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	LDS  R30,_lat
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:54 WORDS
SUBOPT_0x2B:
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2C:
	LDS  R30,_S
	LDS  R31,_S+1
	LDS  R22,_S+2
	LDS  R23,_S+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2D:
	RCALL __CDF1
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	LDI  R30,LOW(_DR*2)
	LDI  R31,HIGH(_DR*2)
	RCALL __GETD1PF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2F:
	RCALL __PUTPARD1
	RCALL _sqrt
	RCALL SUBOPT_0x1B
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x30:
	RCALL __ADDF12
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x31:
	RCALL __ADDF12
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:61 WORDS
SUBOPT_0x32:
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x33:
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x34:
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0x35:
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x36:
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x37:
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x38:
	LDI  R30,LOW(_P2*2)
	LDI  R31,HIGH(_P2*2)
	RCALL __GETD1PF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x39:
	RCALL __PUTPARD1
	RJMP _sin

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x3A:
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x3B:
	RCALL __MULF12
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x3C:
	LDS  R30,_TT
	LDS  R31,_TT+1
	LDS  R22,_TT+2
	LDS  R23,_TT+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3D:
	RCALL __PUTPARD1
	RJMP _cos

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x3E:
	STS  _U,R30
	STS  _U+1,R31
	STS  _U+2,R22
	STS  _U+3,R23
	RJMP SUBOPT_0x32

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x3F:
	__GETD2N 0x40000000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x40:
	RCALL __MULF12
	LDS  R26,_U
	LDS  R27,_U+1
	LDS  R24,_U+2
	LDS  R25,_U+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	__GETD2N 0x38A7C5AC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x42:
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x43:
	LDI  R31,0
	RCALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x44:
	__GETD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x45:
	MOV  R26,R11
	CLR  R27
	CLR  R24
	CLR  R25
	RCALL __CDF2
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x46:
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x22
	RCALL __ADDF12
	RCALL SUBOPT_0x11
	RJMP SUBOPT_0x29

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x47:
	LDS  R26,_aA
	LDS  R27,_aA+1
	LDS  R24,_aA+2
	LDS  R25,_aA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x48:
	LDS  R26,_aD
	LDS  R27,_aD+1
	LDS  R24,_aD+2
	LDS  R25,_aD+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x49:
	LDI  R30,LOW(_K1*2)
	LDI  R31,HIGH(_K1*2)
	RCALL __GETD1PF
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __CWD2
	RCALL __CDF2
	RCALL __MULF12
	LDS  R26,_T0
	LDS  R27,_T0+1
	LDS  R24,_T0+2
	LDS  R25,_T0+3
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x4A:
	STS  _A,R30
	STS  _A+1,R31
	STS  _A+2,R22
	STS  _A+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4B:
	RCALL __SUBF12
	STS  _B,R30
	STS  _B+1,R31
	STS  _B+2,R22
	STS  _B+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4C:
	LDS  R30,_D0
	LDS  R31,_D0+1
	LDS  R22,_D0+2
	LDS  R23,_D0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4D:
	RCALL __PUTPARD1
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x4E:
	STS  _V0,R30
	STS  _V0+1,R31
	STS  _V0+2,R22
	STS  _V0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x4F:
	LDS  R30,_B
	LDS  R31,_B+1
	LDS  R22,_B+2
	LDS  R23,_B+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x50:
	LDS  R30,_V0
	LDS  R31,_V0+1
	LDS  R22,_V0+2
	LDS  R23,_V0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x51:
	LDS  R30,_V2
	LDS  R31,_V2+1
	LDS  R22,_V2+2
	LDS  R23,_V2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x52:
	RCALL __ADDF12
	RCALL SUBOPT_0x11
	__GETD1N 0x40000000
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x53:
	LDS  R26,_B
	LDS  R27,_B+1
	LDS  R24,_B+2
	LDS  R25,_B+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x54:
	LDS  R30,_V1
	LDS  R31,_V1+1
	LDS  R22,_V1+2
	LDS  R23,_V1+3
	__GETD2N 0x40800000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x55:
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x56:
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x57:
	LDS  R26,_V0
	LDS  R27,_V0+1
	LDS  R24,_V0+2
	LDS  R25,_V0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x58:
	STS  _D,R30
	STS  _D+1,R31
	STS  _D+2,R22
	STS  _D+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x59:
	RCALL SUBOPT_0x4F
	RCALL __ANEGF1
	LDS  R26,_D
	LDS  R27,_D+1
	LDS  R24,_D+2
	LDS  R25,_D+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5A:
	RCALL __DIVF21
	STS  _E,R30
	STS  _E+1,R31
	STS  _E+2,R22
	STS  _E+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5B:
	STS  _A0,R30
	STS  _A0+1,R31
	STS  _A0+2,R22
	STS  _A0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5C:
	STS  _D0,R30
	STS  _D0+1,R31
	STS  _D0+2,R22
	STS  _D0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5D:
	LDI  R26,0
	SBRC R2,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5E:
	LDI  R26,0
	SBRC R2,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x5F:
	RCALL __ADDF12
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x60:
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x61:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x62:
	__GETD2MN _aA,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x63:
	LDS  R30,_aA
	LDS  R31,_aA+1
	LDS  R22,_aA+2
	LDS  R23,_aA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x64:
	LDI  R31,0
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x65:
	RCALL SUBOPT_0x3
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x66:
	LDI  R30,LOW(10)
	RCALL __DIVB21U
	MOV  R26,R30
	LDI  R30,LOW(10)
	RCALL __MODB21U
	SUBI R30,-LOW(48)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x67:
	LDI  R30,LOW(10)
	RCALL __MODB21U
	SUBI R30,-LOW(48)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x68:
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x69:
	RCALL SUBOPT_0x17
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6A:
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6B:
	RCALL SUBOPT_0x17
	__GETD1N 0x4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6C:
	STS  _M,R30
	STS  _M+1,R31
	STS  _M+2,R22
	STS  _M+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x6D:
	RCALL __ADDD21
	LDS  R30,_cor
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6E:
	__GETD2N 0x3C
	RCALL __MULD12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6F:
	MOV  R30,R8
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x70:
	MOV  R30,R7
	CLR  R31
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x71:
	__PUTD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x72:
	__GETD2S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x73:
	__GETD2S 5
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x74:
	__GETD2S 5
	RCALL __CWD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x75:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x76:
	__PUTD1S 5
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x77:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x78:
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x3
	RJMP SUBOPT_0x61

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x79:
	RCALL _keypress
	RJMP _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7A:
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x3
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x7B:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7C:
	__PUTD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7D:
	__GETD1S 1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7E:
	__GETD2S 1
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7F:
	__GETD2S 4
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x80:
	RCALL __MULF12
	__GETD2N 0x414A8F4E
	RCALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x81:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x82:
	RCALL __long_delay_G101
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G101


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_sqrt:
	sbiw r28,4
	push r21
	ldd  r25,y+7
	tst  r25
	brne __sqrt0
	adiw r28,8
	rjmp __zerores
__sqrt0:
	brpl __sqrt1
	adiw r28,8
	rjmp __maxres
__sqrt1:
	push r20
	ldi  r20,66
	ldd  r24,y+6
	ldd  r27,y+5
	ldd  r26,y+4
__sqrt2:
	st   y,r24
	std  y+1,r25
	std  y+2,r26
	std  y+3,r27
	movw r30,r26
	movw r22,r24
	ldd  r26,y+4
	ldd  r27,y+5
	ldd  r24,y+6
	ldd  r25,y+7
	rcall __divf21
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	rcall __addf12
	rcall __unpack1
	dec  r23
	rcall __repack
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	eor  r26,r30
	andi r26,0xf8
	brne __sqrt4
	cp   r27,r31
	cpc  r24,r22
	cpc  r25,r23
	breq __sqrt3
__sqrt4:
	dec  r20
	breq __sqrt3
	movw r26,r30
	movw r24,r22
	rjmp __sqrt2
__sqrt3:
	pop  r20
	pop  r21
	adiw r28,8
	ret

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CBD2:
	MOV  R27,R26
	ADD  R27,R27
	SBC  R27,R27
	MOV  R24,R27
	MOV  R25,R27
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__EQD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	LDI  R30,1
	BREQ __EQD12T
	CLR  R30
__EQD12T:
	RET

__LTD12:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	LDI  R30,1
	BRLT __LTD12T
	CLR  R30
__LTD12T:
	RET

__GTD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	LDI  R30,1
	BRLT __GTD12T
	CLR  R30
__GTD12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODB21U:
	RCALL __DIVB21U
	MOV  R30,R26
	RET

__MODD21:
	CLT
	SBRS R25,7
	RJMP __MODD211
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	SUBI R26,-1
	SBCI R27,-1
	SBCI R24,-1
	SBCI R25,-1
	SET
__MODD211:
	SBRC R23,7
	RCALL __ANEGD1
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	BRTC __MODD212
	RCALL __ANEGD1
__MODD212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

;END OF CODE MARKER
__END_OF_CODE:
